const fs = require('fs')
const join = require('path').join
const resolve = require('path').resolve
const config = require('./config')
const addRoutes = require('../lib/routes')
const reqPlugin = resolve(__dirname, '../lib/plugin.js')
const getPages = require('../lib/content/getPages.js')

function createOptions (opts) {
  const options = Object.assign({}, config.defaults, opts.content)
  options.srcPath = opts.srcDir
  options.contentPath = resolve(opts.srcDir, options.srcDir)
  // `config.dirs` can be an Array but for simplicity we only read it as a 2D Array
  if (!Array.isArray(options.dirs[0])) options.dirs = [options.dirs]
  return options
}

module.exports = function () {
  const options = createOptions(this.options)
  this.options.build.loaders.push(config.loader(options))
  // this.addPlugin({ src: reqPlugin })
  this.extendRoutes(routes => addRoutes(routes, options))

  // TODO
  // const pagesData = getPages(options)
  // console.log(Object.keys(pagesData).map(key => pagesData[key].route.path))
  // const backup = this.options.generate && this.options.generate.routes
  // if (!('generate' in this.options)) this.options.generate = {}
  // this.options.generate.routes = async () => {
  //   if (typeof (backup) === 'function') {
  //     pages.concat(await backup())
  //   } else if (Array.isArray(backup)) {
  //     pages.concat(pages)
  //   }
  //   return Object.keys(pagesData).map(key => pagesData[key].route.path)
  // }
}

module.exports.meta = require('../package.json')
